#!/bin/bash
DESTINATION=/opt/thinclient/bin
FILES=/tmp/compile.txt
echo "compile begin"

# compile source
ls $DESTINATION/*.py > $FILES
while read LINE
do
  python3 -m py_compile $LINE
done < $FILES

# move compiled files to bin directory
ls $DESTINATION/__pycache__ > $FILES
while read LINE
do
  FILENAME=$(echo $LINE | cut -f1 -d. )
  mv $DESTINATION/__pycache__/$LINE $DESTINATION/$FILENAME.pyc
done < $FILES

chmod u=rwx,g=rx,o=rx $DESTINATION/*
rmdir $DESTINATION/__pycache__
rm $DESTINATION/*.py
rm $FILES

echo "compile end"
exit 0
