#!/bin/bash
# skeleton for user vpn script
 
# input parameters:
# -f = configuration file
# -o = output file
# -u = user name
# -p = password
# -t = one-time password
# -e = additional parameter

# check input parameters
while getopts f:o:u:p:t:e:h opt
do 
  case $opt in
    f) config=$OPTARG
       ;;
    o) output=$OPTARG
       ;;
    u) user=$OPTARG
       ;;
    p) password=$OPTARG
       ;;
    t) otp=$OPTARG
       ;;
    e) param=$OPTARG
       ;;
  esac
done

cd /data/vpn
# The output must be written to the $output file, otherwise xtc cannot check the status of openvpn. Execute the connection as background process.
# See /opt/thinclient/script/openvpn.sh or /opt/thinclient/script/wireguard.sh

# example for openvpn:
openvpn --config $config $param --auth-pass-file $passfile --log $output &
exit 0
